#ifndef __handler_h
#define __handler_h

#include <config.h>

__BEGIN_SYS
__BEGIN_INT

class Handler
{
public:
    Handler();
    Handler(const Id & id);
    Handler(const Handler & handler);
    ~Handler();

    const Id & id();
    bool valid();

    // methods
};

class Function_Handler
{
public:
    Function_Handler();
    Function_Handler(const Id & id);
    Function_Handler(const Function_Handler & handler);
    ~Function_Handler();

    const Id & id();
    bool valid();

    // methods
};

class Thread_Handler
{
public:
    Thread_Handler();
    Thread_Handler(const Id & id);
    Thread_Handler(const Thread_Handler & handler);
    ~Thread_Handler();

    const Id & id();
    bool valid();

    // methods
};

class Semaphore_Handler
{
public:
    Semaphore_Handler();
    Semaphore_Handler(const Id & id);
    Semaphore_Handler(const Semaphore_Handler & handler);
    ~Semaphore_Handler();

    const Id & id();
    bool valid();

    // methods
};

__END_INT
__END_SYS

#ifdef __FUNCTION_HANDLER_H
#include __FUNCTION_HANDLER_H
#endif

#ifdef __THREAD_HANDLER_H
#include __THREAD_HANDLER_H
#endif

#ifdef __SEMAPHORE_HANDLER_H
#include __SEMAPHORE_HANDLER_H
#endif

#ifdef __FRAMEWORK_H
#include  __FRAMEWORK_H
#endif

#endif

