#ifndef __chronometer_h
#define __chronometer_h

#include <timer.h>
#include "common.h"

__BEGIN_SYS
__BEGIN_IMP

class Chronometer: private Timer_Common
{
public:
    Chronometer();
    ~Chronometer();

    const Time & resolution() { return _resolution; }
    void reset();
    void start();
    void lap();
    void stop();
    Time read();
    Tick ticks();

    static int init(System_Info * si);

protected:
    static Time _resolution;
};

__END_IMP
__END_SYS

#endif

