//============================================================================
// FAST ETHERNET IMPLEMENTATION
//
// Desc: 
//
// Date: 13 Dec 1999			Auth: Guto
//============================================================================
#include <system/debug.h>
#include <fast_ethernet.h>

BEGIN_SYSTEM_NAMESPACE

Fast_Ethernet_Imp::Fast_Ethernet_Imp()
{
  debug(DB_TRACE, DB_NETWORK, "Fast_Ethernet(this=%p,id=%s)\n", 
	this, get_id().dump());
}

Fast_Ethernet_Imp::~Fast_Ethernet_Imp()
{
  debug(DB_TRACE, DB_NETWORK, "~Fast_Ethernet(this=%p,id=%s)\n", 
	this, get_id().dump());
}

int Fast_Ethernet_Imp::reset()
{
  debug(DB_TRACE, DB_NETWORK, "reset() => NOT_IMPLEMENTED\n");
  return NOT_IMPLEMENTED;
}

int Fast_Ethernet_Imp::send(Network_Id id, const void *buf, unsigned int len)
{
  debug(DB_TRACE, DB_NETWORK,
	"send(id=%d,buf=%p,len=%d) => NOT_IMPLEMENTED\n", id, buf, len);
  return NOT_IMPLEMENTED;
}

int Fast_Ethernet_Imp::receive(Network_Id *id, void *buf, unsigned int *len)
{
  debug(DB_TRACE, DB_NETWORK,
	"receive(src=%d,buf=%p,len=%d) => NOT_IMPLEMENTED\n", *id, buf, *len);
  return NOT_IMPLEMENTED;
}

END_SYSTEM_NAMESPACE

